#include"256col.c"
#include"crossspr.c"
#include<math.h>
#include<conio.h>
#define pi 3.14159265

extern unsigned char S[20][20];
unsigned char *V;
float sin1,sin2,cos1,cos2,p=-300,da=pi/20;

void rot(float *C)   //頥    ᮮ.  sin1,sin2...
{float t1,t2;
  t1=C[1];
  t2=C[2];
  C[1]=t1*cos1-t2*sin1;
  C[2]=t1*sin1+t2*cos1;
  t1=C[0];
  t2=C[2];
  C[0]=t1*cos2+t2*sin2;
  C[2]=-t1*sin2+t2*cos2;
}

void stor(int x,int y,int z)
{
int i,j,xs,ys,c,m,n,k;
float C[3];
 for(i=0;i<20;i++)
  {
  for(j=0;j<20;j++)
   {
   C[0]=(j-10)*3;
   C[1]=(i-10)*3;
   C[2]=0;
   rot(C);
   C[2]+=z;
   C[0]-=120-x;
   C[1]-=100-y;
   C[0]*=p/(p-C[2]);
   C[1]*=p/(p-C[2])*0.8333;
   c=fabs(cos1*cos2*(C[2]-105)/210)*26+5;
   xs=C[0]+120;
   ys=C[1]+100;
   k=(120-C[2])/30+1;
   for(m=0;m<k;m++)
    for(n=0;n<k;n++)
      if(inscr(xs+m,ys+n))
       V[(xs+m)+(ys+n)*240]=S[i][j]*32+c;
   }
  }
}

void scr(void)
{int x,y;
for(x=0;x<240;x++)
 for(y=0;y<200;y++)
  putpix(x+40,y,V[x+y*240]);
}

void cscr(void)
{int x,y;
for(x=0;x<240;x++)
for(y=0;y<200;y++)
 V[x+y*240]=0;
}

void setpal(void)
{int i;
for(i=0;i<32;i++)
 setcol(i,i,i,i);
for(i=0;i<32;i++)
 setcol(i+32,0,0,i*2);
for(i=0;i<32;i++)
 setcol(i+64,0,i*2,0);
for(i=0;i<32;i++)
 setcol(i+96,0,i*2,i*2);
for(i=0;i<32;i++)
 setcol(i+128,i*2,0,0);
for(i=0;i<32;i++)
 setcol(i+160,i*2,0,i*2);
for(i=0;i<32;i++)
 setcol(i+192,i*2,i*2,0);
for(i=0;i<32;i++)
 setcol(i+224,i+32,i+32,i+32);
}

void main(void)
{
 float a=2*pi,b=2*pi;
 int z=0,x=120,y=100;
 char k;
 V=(unsigned char *)malloc(48000l);
 if(!V)exit(1);
 init256();
 setpal();
 cscr();
 stor(x,y,z);
 scr();
 while(1)
 {
 k=getch();
  switch(k)
  {
   case 0:
   k=getch();
   switch(k)
   {

   case 72:if(a>=2*pi)a=0;else a+=da;break;
   case 80:if(a<=0)a=2*pi;else a-=da;break;
   case 77:if(b>=2*pi)b=0;else b+=da;break;
   case 75:if(b<=0)b=2*pi;else b-=da;break;
   case 73:if(z>-105)z--;break;
   case 81:if(z<105)z++;break;
   }break;
   case 27:close256();free(V);exit(0);break;
   case '8':y--;break;
   case '2':y++;break;
   case '4':x--;break;
   case '6':x++;break;
  }
 sin1=sin(a);
 sin2=sin(b);
 cos1=cos(a);
 cos2=cos(b);
 cscr();
 stor(x-70,y,z);
 stor(x+70,y,z);
 stor(x,y-70,z);
 stor(x,y+70,z);
 stor(x+70,y+70,z);
 stor(x-70,y+70,z);
 stor(x+70,y-70,z);
 stor(x-70,y-70,z);
 stor(x,y,z);
 scr();
 }
}