#include"graph.c"
#include<conio.h>
#include<math.h>

extern unsigned char V[240][200];


void cube(int x,int y,int z,float a,float b,int col)
{auto float C[8][3]={{-20,20,-20},
                     {-20,-20,-20},
                     {20,-20,-20},
                     {20,20,-20},
                     {-20,20,20},
                     {-20,-20,20},
                     {20,-20,20},
                     {20,20,20}};
 auto char U[6][5]={{0,1,2,3,1},
                    {0,1,5,4,2},
                    {0,4,7,3,3},
                    {6,2,3,7,2},
                    {6,5,4,7,1},
                    {6,2,1,5,3}};
 int i,j,be,en,n,c;
 float t1,t2,max=-50,p=-300,sin1,sin2,cos1,cos2;
 sin1=sin(a),cos1=cos(a),sin2=sin(b),cos2=cos(b);
 for(i=0;i<8;i++)
 {
  t1=C[i][1];
  t2=C[i][2];
  C[i][1]=t1*cos1-t2*sin1;
  C[i][2]=t1*sin1+t2*cos1;
  t1=C[i][0];
  t2=C[i][2];
  C[i][0]=t1*cos2+t2*sin2;
  C[i][2]=-t1*sin2+t2*cos2;
 }
 for(i=5;i>=0;i--)
  {
  max=p;
  for(j=0;j<i;j++)
  {
  t1=(C[U[j][0]][2]+C[U[j][2]][2])/2.0;
  if(t1>max){max=t1;n=j;}
  }
  if(max>(C[U[i][0]][2]+C[U[i][2]][2])/2.0)
   {
   for(j=0;j<5;j++){t1=U[i][j];U[i][j]=U[n][j];U[n][j]=t1;}
   }
  }
 for(i=0;i<8;i++)
 {
  C[i][2]+=z;
  C[i][0]-=120-x;
  C[i][1]-=100-y;
  C[i][0]*=p/(p-C[i][2]);
  C[i][1]*=p/(p-C[i][2])*0.8333;
 }
 for(i=4;i>=0;i--)
 {
  switch(U[i][4])
  {
  case 1:c=fabs(cos1*cos2)*16-(z-120)/16;break;
  case 2:c=fabs(sin2)*16-(z-120)/16;break;
  case 3:c=fabs(sin1*cos2)*16-(z-120)/16;break;
  }
  tri(C[U[i][0]][0]+120,C[U[i][0]][1]+100,C[U[i][1]][0]+120,C[U[i][1]][1]+100,
      C[U[i][2]][0]+120,C[U[i][2]][1]+100,col*32+c);
  tri(C[U[i][0]][0]+120,C[U[i][0]][1]+100,C[U[i][2]][0]+120,C[U[i][2]][1]+100,
      C[U[i][3]][0]+120,C[U[i][3]][1]+100,col*32+c);
 }
}

void scr(void)
{int x,y;
for(x=0;x<240;x++)
 for(y=0;y<200;y++)
  putpix(x+40,y,V[x][y]);
}

void cscr(void)
{int x,y;
for(x=0;x<240;x++)
for(y=0;y<200;y++)
 V[x][y]=0;
}

void setpal(void)
{int i;
for(i=0;i<32;i++)
 setcol(i,i,i,i);
for(i=0;i<32;i++)
 setcol(i+32,0,0,i*2);
for(i=0;i<32;i++)
 setcol(i+64,0,i*2,0);
for(i=0;i<32;i++)
 setcol(i+96,0,i*2,i*2);
for(i=0;i<32;i++)
 setcol(i+128,i*2,0,0);
for(i=0;i<32;i++)
 setcol(i+160,i*2,0,i*2);
for(i=0;i<32;i++)
 setcol(i+192,i*2,i*2,0);
for(i=0;i<32;i++)
 setcol(i+224,i+32,i+32,i+32);
}

void main(void)
{char k;
 float a=0,b=0,da=pi/20.0;
 int z=0,x=120,y=100;
 init256();
 setpal();
 while(1)
 {
  cube(x,y,z,a,b,2);
  scr();
  cscr();
  k=getch();
  switch(k)
  {case 0:
   k=getch();
   switch(k)
   {

   case 72:if(a>=2*pi)a=0;else a+=da;break;
   case 80:if(a<=0)a=2*pi;else a-=da;break;
   case 77:if(b>=2*pi)b=0;else b+=da;break;
   case 75:if(b<=0)b=2*pi;else b-=da;break;
   case 73:if(z>-120)z--;break;
   case 81:if(z<120)z++;break;
   }break;
   case 27:close256();exit(0);break;
   case '8':y--;break;
   case '2':y++;break;
   case '4':x--;break;
   case '6':x++;break;
  }
 }
}